-- ******************************** Variables *******************************
local L = LibStub("AceLocale-3.0"):GetLocale("Titan", true)
local LB = LibStub("AceLocale-3.0"):GetLocale("TitanPals", true)
-- ******************************** Functions *******************************

-- **************************************************************************
-- NAME : TitanPanelPalsButton_SetTooltipText()
-- DESC : Build Firends Tooltip for Titan Panel
-- **************************************************************************
function TitanPanelPalsButton_SetTooltip()
     if ( TitanPals.Settings.UpDateDB ) then
          if ( TitanPals.Settings.CombatDisableTooltip ) then
               ShowFriends();
               TitanPanelPals_CoreUtils("UpDate", TitanPals.Profile.Faction, TitanPals.Profile.Realm, TitanPals.Profile.Player);
          else
               GameTooltip:SetText(LB["TITAN_PALS_CONFIG"], HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
               GameTooltip:AddLine(LB["TITAN_PALS_TOOLTIP_COMBAT"]);
          end
     else 
          if ( TitanPals.Settings.CombatDisableTooltip ) then
               ShowFriends();
               TitanPanelPals_CoreUtils("UpDate", TitanPals.Profile.Faction, TitanPals.Profile.Realm, TitanPals.Profile.Player);
          else
               GameTooltip:SetText(LB["TITAN_PALS_CONFIG"], HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
               GameTooltip:AddLine(LB["TITAN_PALS_TOOLTIP_COMBAT"]);
               return;
          end
     end

     local np, op = GetNumFriends();
     local BNNumF, BNetCount = BNGetNumFriends();
     local ofI, opn, opl, opc, opa, opco, ops, opno, tpcnp, tpai;
     local right, left;
     if ( np == 0 and BNNumF == 0 ) then
          GameTooltip:AddLine(LB["TITAN_PALS_TOOLTIP"], HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
          GameTooltip:AddLine(LB["TITAN_PALS_TOOLTIP_EMPTY"])
     else

          -- RealID Friends
          if ( TitanPals.Settings.ShowBNTooltip ) then
               local BNNumF, BNetCount = BNGetNumFriends();
               local BNI, bnid, FirstN, LastN, BNAFK, BNDND, ToonID, TName, TClient, TRealm, TFaction, TRace, TClass, TGuild, TZone, TLevel, TStatus, TNote, right, left;
               GameTooltip:AddLine(LB["TITAN_PALS_REAL_TOOLTIP"], HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
               if ( BNetCount > 0 ) then
	            for BNI=1, BNetCount do
	                 bnid, FirstN, LastN, _, ToonID, TGame, _, _, BNAFK, BNDND, _, TNote = BNGetFriendInfo(BNI);
                         _, TName, TClient, TRealm, TFaction, TRace, TClass, TGuild, TZone, TLevel = BNGetToonInfo(ToonID);
                         if ( bnid ) then 
                              --TitanPanelPals_DebugUtils("info", "Tooltip", "ID = "..bnid.." \nReal Name "..bnrn.." \nCharacter Name "..bncn.." \nCharacter ID "..bncid.." \nClient "..bngc.." \n Connected "..bnc); 
                              RealIDName = TitanPanelPals_CoreUtils("RealIDN", TitanPals.Settings.RealIDFormat, FirstN, LastN, TName, TRealm, FirstN.." "..LastN, TClass)
                              right, left = TitanPanelPals_CoreUtils("ToolTip", TitanPals.Settings.TFormat, "", RealIDName, TLevel, TClass, TZone, TStats, TNote);
                              GameTooltip:AddDoubleLine(right, left);
                         end
                    end
                    GameTooltip:AddLine("\n");
               else 
                    GameTooltip:AddLine(LB["TITAN_PALS_TOOLTIP_NOREALPALS"]);
                    GameTooltip:AddLine("\n");
               end
          end
          GameTooltip:AddLine(LB["TITAN_PALS_TOOLTIP"], HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);

          -- For showing online friends
          if ( op == 0 ) then GameTooltip:AddLine(LB["TITAN_PALS_TOOLTIP_NOPALS"]);
          else
               for ofI=1, np do
                    opn, opl, opc, opa, opco, ops, opno = GetFriendInfo(ofI);
                    if ( opco ) then
                         right, left = TitanPanelPals_CoreUtils("ToolTip", TitanPals.Settings.TFormat, "", opn, opl, opc, opa, ops, opno);
                         GameTooltip:AddDoubleLine(right, left);
                    end
               end
          end

	  -- For showing ignored ppl
          if ( TitanPals.Settings.ShowIgnored ) then
               GameTooltip:AddLine("\n");
               GameTooltip:AddLine(TitanPanelPals_ColorUtils("GetCText", "hlight", LB["TITAN_PALS_TOOLTIP_IGNORE"]));
               ni = GetNumIgnores();
               if ( ni == 0 ) then 
	            GameTooltip:AddLine(LB["TITAN_PALS_TOOLTIP_IGNORE_EMPTY"]);
               else
                    for ofI=1, ni do
                         local tpit = TitanPanelPals_ColorUtils("GetCText", "red", LB["TITAN_PALS_TOOLTIP_OFFLINE_IGNORED"]);
                         GameTooltip:AddDoubleLine("  "..TitanPanelPals_ColorUtils("GetCText", "normal", GetIgnoreName(ofI)), tpit);
                    end
               end
          end
     end
     -- For showing AddOn memory Usage
     if ( TitanPals.Settings.ShowMem ) then
          GameTooltip:AddLine("\n");
          GameTooltip:AddLine(TitanPanelPals_ColorUtils("GetCText", "hlight", LB["TITAN_PALS_TOOLTIP_MEM"]));
	  GameTooltip:AddDoubleLine("  "..LB["TITAN_PALS_CONFIG"], TitanPanelPals_ColorUtils("GetCText", "green", floor(GetAddOnMemoryUsage('TitanPals')).."kb"))
     end
end

-- **************************************************************************
-- NAME : TitanPanelPals_FixPalsEcho()
-- DESC : <research>
-- **************************************************************************
function TitanPanelPals_FixPalsEcho(level, class, name)		
	local class = TitanPanelPals_ColorUtils("GetCClass", "color", class, class);
	local name = TitanPanelPals_ColorUtils("GetCClass", "color", class, name);
	return "Fixing Pals ["..name.."] Class = ["..class.."] Level = ["..TitanPanelPals_ColoredUtils("GetCText", "orange", level).."]";
end

-- **************************************************************************
-- NAME : TitanPalsUtils_FixPal()
-- DESC : <research>
-- **************************************************************************
function TitanPalsUtils_FixPal(PN, PC, PL)
	if ( PC == "1" ) then PC = "Warrior";
	elseif ( PC == "2" ) then PC = "Mage";
	elseif ( PC == "3" ) then PC = "Warlock";
	elseif ( PC == "4" ) then PC = "Paladin";
	elseif ( PC == "5" ) then PC = "Priest";
	elseif ( PC == "6" ) then PC = "Hunter";
	elseif ( PC == "7" ) then PC = "Shaman";
	elseif ( PC == "8" ) then PC = "Rogue";
	elseif ( PC == "9" ) then PC = "Druid";
	elseif ( PC == "10" ) then PC = "Death Knight"; end
	local printLine = TitanPanelPals_FixPalsEcho(PL, PC, PN);
	TitanPals.Lists.palsDB.PN.class = PC;
	TitanPals.Lists.palsDB.PN.level = PL;
end